/*
 * Hello World class
 */

#ifdef HAVE_TCLOBJ
#include <tcl.h>
#include <tclobj.h>
#endif


#ifdef HAVE_TCLOBJ
class HelloWorld : public Tcl_Object
#else
class HelloWorld
#endif
{
public:
  HelloWorld (void);
  const char * hello (void) const;
  const char * world (void) const;

#ifdef HAVE_TCLOBJ
  HelloWorld   (Tcl_Interp *, int, char *[], int);
  int Tcl_Proc (Tcl_Interp *, int, char *[], int);
  TCL_OBJECT_DECL_CLASS(HelloWorld);
#endif
};

HelloWorld::HelloWorld (void)
{
  /* space for rent */
}

const char *
HelloWorld::hello (void) const
{
  return "hello";
}

const char *
HelloWorld::world (void) const
{
  return "world";
}

#ifdef HAVE_TCLOBJ

static const TclObj_Comtab hwctab[] = {
  /* constructors */
  { 1, "new",   "", "construct \"HelloWorld\" object" },

  /* members */
  { 1, "hello", "", "get \"hello\" part of \"hello world\"" },
  { 2, "world", "", "get \"world\" part of \"hello world\"" },
  { 3, "copy",  "HelloWorld", "copy from another object" },
  { 0, NULL, NULL, NULL }
};

TCL_OBJECT_DECL_BODY(HelloWorld,Tcl_Object,hwctab,NULL);

HelloWorld::HelloWorld (Tcl_Interp *interp,
			int argc, char *argv[],
			int command)
{
  /* nothing to initialize */
}

int
HelloWorld::Tcl_Proc (Tcl_Interp *interp,
		      int argc, char *argv[],
		      int command)
{
  HelloWorld *TheOther;

  switch (command) {
  case 1: /* hello */
    return TCL_OBJECT_RETURN_STRING(interp, hello());

  case 2: /* world */
    return TCL_OBJECT_RETURN_STRING(interp, world());

  case 3: /* copy HelloWorld */
    TheOther= TCL_OBJECT_ARG_OBJECT(interp, argv[2],
                                    HelloWorld);
    operator= (*TheOther);
    return TCL_OBJECT_RETURN_OBJECT(interp, this);
  }
  TCL_OBJECT_NO_MATCH(interp);
}

/*
 * Because Tcl's load command cannot handle our mixed case class
 * name, we need an all-lowercase package name
 */

TCL_OBJECT_BEGIN_PACKAGE(helloworld);
TCL_OBJECT_PKG_CLASS(HelloWorld);
TCL_OBJECT_END_PACKAGE();

#endif
